#include <windows.h>

#include "win069.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground = GetSysColorBrush(COLOR_WINDOW);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 069",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    /* Variables para dilogo */
    static HFONT hfont;
    static HBRUSH pincel;
    static BOOL marcado;
    HWND hctrl;
    static HBITMAP boton1, boton2, boton3, bitmapsel;
    LPDRAWITEMSTRUCT lpdis;
    char cad[128];
    RECT re;
    HDC memDC;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           marcado = FALSE;
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           hfont = CreateFont(20, 0, 0, 0, 300,
              FALSE, FALSE, FALSE, DEFAULT_CHARSET,
              OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
              PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN,
              "Times New Roman");
           boton1 = LoadBitmap(hInstance,  "Boton1");
           boton2 = LoadBitmap(hInstance,  "Boton2");
           boton3 = LoadBitmap(hInstance,  "Boton3");
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "BUTTON",        /* Nombre de la clase */
              "Inhibir",       /* Texto del ttulo */
              BS_TEXT |
              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, /* Estilo */
              9, 9,            /* Posicin */
              91, 24,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_BOTON1,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           SetFocus(hctrl);
           hctrl = CreateWindowEx(
              0,
              "BUTTON",        /* Nombre de la clase */
              "Desinhibir",    /* Texto del ttulo */
              BS_TEXT |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              130, 9,          /* Posicin */
              91, 24,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_BOTON3,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(
              0,
              "BUTTON",        /* Nombre de la clase */
              "Botn 2",       /* Texto del ttulo */
              BS_OWNERDRAW |
              //BS_ICON |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              9, 39,           /* Posicin */
              164, 35,         /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_BOTON2, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           return 0;
        case WM_DRAWITEM:
           lpdis = (LPDRAWITEMSTRUCT)lParam;
           SendDlgItemMessage(hwnd, (UINT)wParam, WM_GETTEXT, 128, (LPARAM)cad);
           GetClientRect(lpdis->hwndItem, &re);
           SetBkMode(lpdis->hDC, TRANSPARENT);
           pincel = CreateSolidBrush(GetSysColor(COLOR_WINDOW));
           FillRect(lpdis->hDC, &re, pincel);
           if(wParam == ID_BOTON2) {
              if(marcado) {
                bitmapsel = boton2;
              } else {
                bitmapsel = boton1;
              }
              if(lpdis->itemState & ODS_DISABLED)
                bitmapsel = boton3;

              SelectObject(lpdis->hDC, (HPEN)GetStockObject(WHITE_PEN));
              memDC = CreateCompatibleDC(lpdis->hDC);
              SelectObject(memDC, bitmapsel);
              BitBlt(lpdis->hDC, 0, 0, 164, 35, memDC, 0, 0, SRCCOPY);
              if(lpdis->itemState & ODS_SELECTED) {
                 SetTextColor(lpdis->hDC, RGB(240,140,140));
              } else if(lpdis->itemState & ODS_DISABLED) {
                 SetTextColor(lpdis->hDC, RGB(240,140,140));
              } else {
                 SetTextColor(lpdis->hDC, RGB(240,240,240));
              }
              DeleteDC(memDC);
              TextOut(lpdis->hDC, re.left+42, re.top+4, cad, strlen(cad));
              if(lpdis->itemState & ODS_FOCUS) {
                 re.left += 40;
                 re.top += 4;
                 re.right = re.left+76;
                 re.bottom = re.top+20;
                 DrawFocusRect(lpdis->hDC, &re);
              }
           }
           DeleteObject(pincel);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
              case ID_BOTON2:
                marcado = !marcado;
                InvalidateRect(GetDlgItem(hwnd, ID_BOTON2), NULL, TRUE);
                break;
              case ID_BOTON1:
                EnableWindow(GetDlgItem(hwnd, ID_BOTON2), FALSE);
                break;
              case ID_BOTON3:
                EnableWindow(GetDlgItem(hwnd, ID_BOTON2), TRUE);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           DeleteObject(boton1);
           DeleteObject(boton2);
           DeleteObject(boton3);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
